package de.hazewood.rylius.mlgj1.elements.chars;

import de.hazewood.rylius.mlgj1.Element;
import de.hazewood.rylius.mlgj1.Game;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Sound;
import org.newdawn.slick.geom.Vector2f;

public class Applejack extends Element/* of Honesty*/ {

    private boolean leaving;
    private Element attached;
    private Vector2f attachedOffset;
    private Sound splash;

    public Applejack() {
        super(Game.image("ponies/aj_1"));
        splash = Game.sound("splash");
        leaving = false;
    }

    @Override
    public void update(GameContainer gc, int delta) {
        super.update(gc, delta);

        if (attached != null) {
            attached.getPos().set(getPos());
            attached.getPos().add(attachedOffset);
        }

        if (splash != null && pos.getY() > 550) {
            splash.play();
            splash = null;
        }

        if (clicked(gc.getInput())) {
            level.addEvent("applejack", this, null);
        }
    }

    @Override
    public void draw(GameContainer gc, Graphics g) {
        if (leaving) {
            image.draw(pos.getX() + image.getWidth(), pos.getY(), -image.getWidth(), image.getHeight());
        } else {
            image.draw(pos.getX(), pos.getY());
        }
        if (attached != null) {
            attached.draw(gc, g);
        }
    }

    public void leave() {
        leaving = true;
        vel.set(4, 0);
    }

    public boolean left() {
        return pos.getX() > 850;
    }

    @Override
    public boolean combine(Element other) {
        return false;
    }

    public void attach(Element el, Vector2f offset) {
        attached = el;
        attachedOffset = offset;
    }
}
