package de.hazewood.rylius.mlgj1.elements.props;

import de.hazewood.rylius.mlgj1.Element;
import de.hazewood.rylius.mlgj1.Game;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Vector2f;

public class Apple extends Element {

    private Vector2f offset;
    private int ground;

    public Apple() {
        super(Game.image("props/apple"));
        offset = new Vector2f();
        ground = 400;
    }

    public void activate() {
        if (!onGround()) {
            setGravity(new Vector2f(0, 1));
        } else {
            setGravity(new Vector2f(0, -1));
        }
    }

    @Override
    public boolean combine(Element other) {
        return false;
    }

    @Override
    public void update(GameContainer gc, int delta) {
        vel.add(gravity);
        if (onGround() && vel.getY() > 0) {
            vel.set(0, 0);
        }
        pos.add(vel);

        if (pos.getY() + offset.getY() < -100 || pos.getY() + offset.getY() > 700) {
            removeable = true;
        }

        if (clicked(gc.getInput())) {
            level.addEvent("apple", this, null);
        }
    }

    @Override
    public void draw(GameContainer gc, Graphics g) {
        image.draw(pos.getX() + offset.getX(), pos.getY() + offset.getY());
    }

    public boolean onGround() {
        return pos.getY() + offset.getY() > ground;
    }

    @Override
    public boolean hovered(int mx, int my) {
        return image != null && mx > pos.getX() + offset.getX() && mx < pos.getX() + offset.getX() + image.getWidth() && my > pos.getY() + offset.getY() && my < pos.getY() + offset.getY() + image.getHeight() && image.getColor((int) (mx - pos.getX() - offset.getX()), (int) (my - pos.getY() - offset.getY())).a > 0;
    }

    public void setOffset(Vector2f offset) {
        this.offset = offset;
    }

    public Vector2f getOffset() {
        return offset;
    }

    public void setGround(int ground) {
        this.ground = ground;
    }

    public void explode() {
        removeable = true;
    }
}
