package de.hazewood.rylius.mlgj1.particles;

import de.hazewood.rylius.mlgj1.Element;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Image;

public class Particle extends Element {

    private int ground;

    public Particle(Image img) {
        super(img);
    }

    @Override
    public void update(GameContainer gc, int delta) {
        vel.add(gravity);
        if (onGround() && vel.getY() > 0) {
            vel.set(0, 0);
            removeable = true;
        }
        pos.add(vel);

        if (pos.getX() < -100 || pos.getX() > 900 || pos.getY() < -100 || pos.getY() > 700) {
            removeable = true;
        }
    }

    public boolean onGround() {
        return pos.getY() > ground;
    }

    public void setGround(int ground) {
        this.ground = ground;
    }

    @Override
    public boolean combine(Element other) {
        return false;
    }
}
